<?php
// POS command: Do not modify 
include_once 'PHPLibraries/GlobalFunctions.php';
include_once 'PHPLibraries/DBFunctions.php';

global $TempShowDelayNote;
global $TempShowReleaseDateNote;

function ResetCart()
{
	$_SESSION['Products'] = array();
	$_SESSION['ShippingLocation'] = 0; //Automatically set the first shippable region
	//$_SESSION['Settings'] = array();
	$_SESSION['Order.No'] = 'NC'.time();
	$_SESSION['Order.Time'] = time();
	
	DBGetSettings();
}

function AddProductToCart($TempProduct)
{	
	$TempProductInArray = GetProductFromProductArray($TempProduct['ID']);
	
	if ($TempProductInArray == '')
	{
		// Add the product to the Session Products array
		$TempProductArray = array();
		$TempProductArray['Product'] = $TempProduct;
		$TempProductArray['ID'] = $TempProduct['ID'];
		$TempProductArray['Quantities'] = GetBundlesQtyArray($TempProduct);
		$TempProductArray['Status'] = DBGetProductStatus($TempProduct);
		$TempProductArray['PropertyValues'] = DBGetProductPropertyValuesArray($TempProduct);
		
		$_SESSION['Products'][] = $TempProductArray;
		
	}
	else
	{
		// The product is already in the cart
		//echo "Already in cart.";
	}
	
}

function ModifyCartQuantity($TempProduct, $TempPostData)
{
	
	$TempProductArray = GetProductFromProductArray($TempProduct['ID']);
	
	$TempQtyCount = count(GetBundlesQtyArray($TempProduct));
	
	$TempQuantities = $TempProductArray['Quantities'];
	
		foreach ($TempPostData as $key => $value)
		{
			
			$TempIndex = substr($key,1);
			
			if ($TempIndex <= $TempQtyCount-1)
			{
				
				$TempQuantities[$TempIndex] = $value;
				
				// Verify if the quantity requested is in stock
				
				if ($TempIndex == 0)
				{
					// Single item
					
					if ($value > $TempProduct['InStock'] and $TempProduct['SpecialOrderDelayWeeks'] == '' and $TempProduct['UseReleaseDate'] == false)
					{
						$TempQuantities[$TempIndex] = $TempProduct['InStock'];
					}
				}
				else
				{
					// Bundle item
					
					$TempBundles = $TempProduct['Bundles'];
					
					if ($value > $TempBundles[($TempIndex - 1)]['InStock'] and $TempProduct['SpecialOrderDelayWeeks'] == '' and $TempProduct['UseReleaseDate'] == false)
					{
						$TempQuantities[$TempIndex] = $TempBundles[($TempIndex - 1)]['InStock'];
					}
				}
				
			}
		}
		
	$TempProductArray['Quantities'] = $TempQuantities;
	
	SetProductToProductArray($TempProduct['ID'], $TempProductArray);
	
}

function ModifyShippingLocation($TempNewLocation)
{
	$_SESSION['ShippingLocation'] = $TempNewLocation;
}

function RemoveProductFromCart($TempProductID)
{
	$TempProductIndex = GetProductIndexFromProductArray($TempProductID);
	
	if ($TempProductIndex > -1)
	{
		RemoveItemFromArray($_SESSION['Products'], $TempProductIndex);
	}
	
}

function ShowResults($TempProducts)
{
	$TempTongue = $_SESSION['Tongue'];
	$TempCurrentProperty = $_SESSION['Sort'];
	
	$TempPropertiesIndex = LoadUTF8FileIntoArray('Data/ProductPropertiesIndex.php');
	$TempPropertiesValuesIndex = LoadUTF8FileIntoArray('Data/ProductPropertiesValuesIndex.php');
	
	$TempCurrentPropertyName = $TempPropertiesIndex[$TempCurrentProperty];
	
	//[GeneralOrLatestProductsSection]
	$TempGeneralSectionTemplate = LoadFile('Templates/TTemplateSearchResultsGeneral'.$TempTongue.'.txt');
	$TempLatestSectionTemplate = LoadFile('Templates/TTemplateSearchResultsLatestProducts'.$TempTongue.'.txt');

	$TempTemplate = LoadFile('Templates/TTemplateSearchResultsPagePropertyLinkResults'.$TempTongue.'.txt');
	$TempSmallProduct = LoadFile('Templates/TTemplateProductSmallRegularPrice'.$TempTongue.'.txt');
	$TempSmallProductSpecial = LoadFile('Templates/TTemplateProductSmallDiscountedPrice'.$TempTongue.'.txt');
	
	$TempTemplate = str_replace("<body>", '<body>'."\r\n".'<!-- Web site generated by Takkou (http://takkou.com) -->', $TempTemplate);

	$TempTemplate = str_replace("</body>", '<!-- Web site generated by Takkou (http://takkou.com) -->'."\r\n</body>", $TempTemplate);
	
	$TempAllPropertiesValues = array(); // For sorting
	
	$TempResultsHtml = '';
	
	// Property Values
	$TempFormatProperties = array();
	
	if (file_exists('Data/PropertiesUseNumberFormat.txt'))
	{
		$TempFormatProperties = LoadFileIntoArray('Data/PropertiesUseNumberFormat.txt');	
	}

	for ($t = 0; $t <= count($TempProducts) - 1; $t++)
	{
		$TempProduct = $TempProducts[$t];
		$TempPropertyValues = $TempProduct['PropertyValues'];
		
		// Add the properties for sorting links
		for ($g = 0; $g <= count($TempPropertyValues) - 1; $g++)
		{
			if (!in_array($TempPropertyValues[$g]['Name'][0], $TempAllPropertiesValues))
			{
				$TempAllPropertiesValues[] = $TempPropertyValues[$g]['Name'][0];
			}
		}
		
		if ($TempProduct['Price']['Discount']['DiscountType'] == 'None')
		{
			$TempProductTemplate = $TempSmallProduct;
		}
		else
		{
			$TempProductTemplate = $TempSmallProductSpecial;
		}
		
		$TempProductTemplate = str_replace('[Object.Name]', $TempProduct['Name'], $TempProductTemplate);
					
		$TempProductTemplate = str_replace('[Object.Price]', number_format(GetMemberPrice($TempProduct['Price']),2), $TempProductTemplate);

		$TempProductTemplate = str_replace('[Object.Bundles.Price]', GetBundlesPrices($TempProduct['Bundles']), $TempProductTemplate);
		$TempProductTemplate = str_replace('[Object.Discount]', number_format(DBGetFinalPrice($TempProduct['Price']),2), $TempProductTemplate);
		
		$TempProductAddToCartTemplate = DBGetAddToCartProductTemplate($TempProduct);
		$TempProductTemplate = str_replace('[AddToCart]', $TempProductAddToCartTemplate, $TempProductTemplate);
		
		$TempPropertyValue = '';
		
		$TempPropertyValue = GetPropertyValue($TempProduct['PropertyValues'], $TempCurrentPropertyName);

		// If the property is a number, format it

		$TempNameIndex = array_search($TempCurrentPropertyName, $TempPropertiesIndex) + 1;

		$TempValue = Translate($TempPropertyValue, $TempTongue);
		
			if (in_array($TempNameIndex, $TempFormatProperties) && $TempValue != "")
			{
				if (strpos($TempValue,".") > 0)
				{
				  $TempValue = number_format($TempValue, 2, ".", ",");
				}
				else
				{
				  $TempValue = number_format($TempValue, 0, ".", ",");
				}
			}
			
		
		$TempProductTemplate = str_replace('[PropLinkName]', $TempValue, $TempProductTemplate);
		
		$TempPropertyValueIndex = array_search($TempPropertyValue, $TempPropertiesValuesIndex);
		
		$TempProductTemplate = str_replace('[PropLinkURL]', 'Show.php?Data='.$TempCurrentProperty.','.$TempPropertyValueIndex.'&Sort='.$_SESSION['Settings']['DefaultSortProperty'], $TempProductTemplate);
		
		$TempProductTemplate = str_replace('[ProductLink]', 'Product.php?ID='.$TempProduct['ID'], $TempProductTemplate);

		// [Thumbnail]
		$TempThumbCode = '<img border="0" src="Pictures/[FileName]">';
		$TempThumbCode = str_replace('[ID]', $TempProduct['ID'], $TempThumbCode);
		
		if (count($TempProduct['Pictures.FileName']) > 0)
		{
			$TempThumbFileName = $TempProduct['Pictures.FileName'][0];
			$TempThumbFileName = GetThumbnailFileName($TempThumbFileName);

			$TempThumbCode = str_Replace('[FileName]', $TempThumbFileName, $TempThumbCode);

			$TempProductTemplate = str_replace('[Thumbnail]', $TempThumbCode, $TempProductTemplate);
			
			$TempCorrectedName = str_replace('\\', '/', $TempProduct['Pictures.FileName'][0]);
			$TempProductTemplate = str_replace('[MainPictureFileName]', $TempCorrectedName, $TempProductTemplate);
		}
		else
		{
			// No pictures !!!!!!!!!!! ==================
			$TempExtension = '';
			
			if (file_exists('Pictures/NoPicture.png'))
			{
				$TempExtension = ".png";
			}
			else
			{
				if (file_exists('Pictures/NoPicture.gif'))
				{
					$TempExtension = ".gif";
				}
				else
				{
					if (file_exists('Pictures/NoPicture.jpg'))
					{
						$TempExtension = ".jpg";
					}
				}
			}
			
			if ($TempExtension <> '')
			{
				$TempThumbFileName = 'NoPicture'.$TempExtension;
				$TempThumbFileName = 'NoPicture'.$TempExtension;

				$TempThumbCode = str_Replace('[FileName]', $TempThumbFileName, $TempThumbCode);

				$TempProductTemplate = str_replace('[Thumbnail]', $TempThumbCode, $TempProductTemplate);
			
				$TempCorrectedName = str_replace('\\', '/', 'NoPicture'.$TempExtension);
				$TempProductTemplate = str_replace('[MainPictureFileName]', $TempCorrectedName, $TempProductTemplate);
			}
			else
			{
				$TempProductTemplate = str_replace('[Thumbnail]', 'No pictures!', $TempProductTemplate);
			}
			
		}
		
		// End [Thumbnail]
		
		$TempResultsHtml = $TempResultsHtml.$TempProductTemplate;
	}
	
	$TempTemplate = str_replace('[ProductResults]',$TempResultsHtml,$TempTemplate);
	
	// Add Sort links
	$TempSortLinks = '';

	$TempPropertyIndex = array();
	
	for ($t = 0; $t <= count($TempAllPropertiesValues) - 1; $t++)
	{
		$TempPropertyIndex[Translate($TempAllPropertiesValues[$t], $TempTongue)] = array_search($TempAllPropertiesValues[$t], $TempPropertiesIndex);
	}

	$TempPropertiesToExcludeFromSort = LoadPropertiesToExcludeFromSort();
	$TempPropertiesToExcludeFromSort = TranslateArray($TempPropertiesToExcludeFromSort, $TempTongue);
	
	$TempAllPropertiesValues = TranslateArray($TempAllPropertiesValues, $TempTongue);
	
	$TempAllPropertiesValues = SortAccentedArray($TempAllPropertiesValues);

	for ($t = 0; $t <= count($TempAllPropertiesValues) - 1; $t++)
	{
		if (!in_array($TempAllPropertiesValues[$t], $TempPropertiesToExcludeFromSort))
		{
			//$TempPropertyIndex = array_search($TempAllPropertiesValues[$t], $TempPropertiesIndex);
			$TempLink = 'Show.php?Data='. $_GET['Data'].'&Sort='.$TempPropertyIndex[$TempAllPropertiesValues[$t]];
			//<a href="Link">sdfdsf</a>
			$TempLink = '<a href="'.$TempLink.'">'.$TempAllPropertiesValues[$t].'</a>';		
			$TempSortLinks = $TempSortLinks.$TempLink."<br>";
		}
	}

	//$TempAllPropertiesValues = TranslateArray($TempAllPropertiesValues, $TempTongue);
	
	$TempOriginalSectionName = '';
	$TempSection = '';
	
	if (array_key_exists('$_GET[Data]', $_SESSION))
	{
		$TempSection = $_SESSION['$_GET[Data]'];
		$TempOriginalSectionName = $TempSection;
		$TempSection = substr($TempSection,strpos($TempSection,",") + 1);
		if (strpos($TempSection, ',') > -1)
		{
			$TempSection = substr($TempSection,0,strpos($TempSection,",") );
		}
	

	}

	if (strpos($TempTemplate, "[GeneralOrLatestProductsSection]")>0)
	{
		if ($TempOriginalSectionName == "Main")
		{
		// $TempLatestSectionTemplate
			$TempTemplate = str_replace('[GeneralOrLatestProductsSection]', $TempLatestSectionTemplate, $TempTemplate);
		}
		else
		{
		// $TempGeneralSectionTemplate
			$TempTemplate = str_replace('[GeneralOrLatestProductsSection]', $TempGeneralSectionTemplate, $TempTemplate);	  
		}
	}
	$TempTemplate = str_replace('[Section]', Translate($TempPropertiesValuesIndex[$TempSection], $TempTongue), $TempTemplate);

	$TempTemplate = str_replace('[SortLinks]',$TempSortLinks,$TempTemplate);
	
	$TempTemplate = str_replace('[Sort]', Translate($TempCurrentPropertyName, $TempTongue), $TempTemplate);

	
	$TempTemplate = FillPageTemplate($TempTemplate);
	
	echo $TempTemplate;
}

function GetBundlesPrices($TempBundles, $TempTemplate = '', $TempSpecialTemplate = '')
{
	$TempReturn = '';
	$TempTongue = $_SESSION['Tongue'];

	if ($TempTemplate == '')
	{
	
		for ($t = 0; $t <= count($TempBundles)-1; $t++)
		{
			$TempBundle = $TempBundles[$t];
			
			if ($TempBundle['Price']['Price'] != DBGetFinalPrice($TempBundle['Price']))
			{
				// Special
				$TempReturn = $TempReturn."<strike>".number_format($TempBundle['Price']['Price'],2)."</strike> ".number_format(DBGetFinalPrice($TempBundle['Price']),2).'$ ';
				$TempReturn = $TempReturn.GetStringListItemWithZeroFallBack($TempBundle['Name'], $TempTongue).' ('.$TempBundle['Quantity'].') ';
			}
			else
			{
				$TempReturn = $TempReturn.number_format(DBGetFinalPrice($TempBundle['Price']),2).'$ ';
				$TempReturn = $TempReturn.GetStringListItemWithZeroFallBack($TempBundle['Name'], $TempTongue).' ('.$TempBundle['Quantity'].') ';
			}
			
			if ($t < count($TempBundles)-1)
			{
				$TempReturn = $TempReturn."<br>";
			}
		}
    }
	else
	{
		for ($t = 0; $t <= count($TempBundles)-1; $t++)
		{
			$TempOriginalTemplate = $TempTemplate;
			$TempBundle = $TempBundles[$t];
			$TempTemplate = str_replace("[Bundle.Price]",number_format(DBGetFinalPrice($TempBundle['Price']),2), $TempTemplate);
			$TempTemplate = str_replace("[Bundle.Name]",GetStringListItemWithZeroFallBack($TempBundle['Name'], $TempTongue), $TempTemplate);
			$TempTemplate = str_replace("[Bundle.Quantity]",$TempBundle['Quantity'], $TempTemplate);
			$TempReturn = $TempReturn.$TempTemplate;
			$TempTemplate = $TempOriginalTemplate;
		}
	}
	return $TempReturn;
}

function ShowCart($TempTongue, $TempShow = true, $TempCartTemplate = '', $TempReadOnly = false)
{
	global $TempShowDelayNote;
	global $TempShowReleaseDateNote;
	
	if (!array_key_exists('Order.No', $_SESSION))
	{
		$TempOrderNo = time();
		
		while (strlen($TempOrderNo) < 10)
		{
			$TempOrderNo = $TempOrderNo.'0';
		}
		
		$_SESSION['Order.No'] = 'NC'.$TempOrderNo;
	}

	if (!array_key_exists('User.Name', $_SESSION))
	{
		$_SESSION['User.Name'] = '';
	}

	if (!array_key_exists('User.Phone', $_SESSION))
	{
		$_SESSION['User.Phone'] = '';
	}

	if (!array_key_exists('User.Email', $_SESSION))
	{
		$_SESSION['User.Email'] = '';
	}

	//$TempCartTemplate = '';
	$TempCartSingleItemTemplate = '';
	$TempCartSingleItemSpecialTemplate = '';
	
	if ($TempShow)
	{
		if ($TempCartTemplate <> '')
		{
			$TempCartTemplate = LoadFile('Templates/'.$TempCartTemplate.$TempTongue.'.txt');
		}
		else
		{
			$TempCartTemplate = LoadFile('Templates/TTemplateCartPage'.$TempTongue.'.txt');
		}
		
		if ($TempReadOnly == true)
		{
			$TempCartSingleItemTemplate = LoadFile('Templates/TTemplateConfirmedOrderEmailProduct'.$TempTongue.'.txt');
			$TempCartSingleItemSpecialTemplate = $TempCartSingleItemTemplate;
		}
		else
		{
			$TempCartSingleItemTemplate = LoadFile('Templates/TTemplateCartProductRegularPrice'.$TempTongue.'.txt');
			$TempCartSingleItemSpecialTemplate = LoadFile('Templates/TTemplateCartProductDiscountedPrice'.$TempTongue.'.txt');
		}
	}
	else
	{
		$TempCartTemplate = LoadFile('Templates/TTemplateConfirmedOrderEmail'.$TempTongue.'.txt');
		$TempCartSingleItemTemplate = LoadFile('Templates/TTemplateConfirmedOrderEmailProduct'.$TempTongue.'.txt');
		$TempCartSingleItemSpecialTemplate = $TempCartSingleItemTemplate;
	}

	$TempOutTemplate = '';
	
	for ($t = 0; $t <= count($_SESSION['Products']) - 1; $t++)
	{
		$TempDiscountType = $_SESSION['Products'][$t]['Product']['Price']['Discount']['DiscountType'];
		
		if ($TempDiscountType == 0)
		{
			if ($TempReadOnly == true)
			{
				$TempOutTemplate = $TempOutTemplate.FillCartItemData($TempCartSingleItemTemplate, $TempTongue, $_SESSION['Products'][$t], false);
			}
			else
			{
				$TempOutTemplate = $TempOutTemplate.FillCartItemData($TempCartSingleItemTemplate, $TempTongue, $_SESSION['Products'][$t], $TempShow);
			}
		}
		else
		{
			if ($TempReadOnly == true)
			{
				$TempOutTemplate = $TempOutTemplate.FillCartItemData($TempCartSingleItemSpecialTemplate, $TempTongue, $_SESSION['Products'][$t], false);
			}
			else
			{
				$TempOutTemplate = $TempOutTemplate.FillCartItemData($TempCartSingleItemSpecialTemplate, $TempTongue, $_SESSION['Products'][$t], $TempShow);
			}
		}
		
	}
	
	$TempCartTemplate = FillCartData($TempCartTemplate, $TempTongue);

	$TempCartTemplate = str_replace('[Cart.InStock]', $TempOutTemplate, $TempCartTemplate);
	$TempCartTemplate = str_replace('[Language]', $TempTongue, $TempCartTemplate);

	$TempCartTemplate = str_replace('[Order.No]', $_SESSION['Order.No'], $TempCartTemplate);
	$TempCartTemplate = str_replace('[Order.Date]', gmdate('Y/m/d H:i:s'), $TempCartTemplate);

	$TempCartTemplate = str_replace('[MemberLogin]', GetLoginTemplate($TempTongue), $TempCartTemplate);
	$TempCartTemplate = str_replace('[Member.Name]', GetLoginName(), $TempCartTemplate);
	
	if (!array_key_exists('User.Name', $_SESSION))
	{
	$_SESSION['User.Name'] = '';
	}

	if (!array_key_exists('User.Phone', $_SESSION))
	{
	$_SESSION['User.Phone'] = '';
	}

	if (!array_key_exists('User.Email', $_SESSION))
	{
	$_SESSION['User.Email'] = '';
	}

	if (!array_key_exists('User.Notes', $_SESSION))
	{
	$_SESSION['User.Notes'] = '';
	}
	
	if (!array_key_exists('User.CouponCode', $_SESSION))
	{
	$_SESSION['User.CouponCode'] = '';
	$_SESSION['User.CouponData'] = '';
	}

	$TempCartTemplate = str_replace('[User.Name]', $_SESSION['User.Name'], $TempCartTemplate);
	$TempCartTemplate = str_replace('[User.Phone]', $_SESSION['User.Phone'], $TempCartTemplate);
	$TempCartTemplate = str_replace('[User.Email]', $_SESSION['User.Email'], $TempCartTemplate);
	$TempCartTemplate = str_replace('[User.Notes]', $_SESSION['User.Notes'], $TempCartTemplate);

	$TempCartTemplate = str_replace('[User.CouponCode]', $_SESSION['User.CouponCode'], $TempCartTemplate);
	
	if ($_SESSION['User.Name'] == '')
	{
		$TempCartTemplate = str_replace('[User.Name.RequiredDataColor]', 'FFFF00', $TempCartTemplate);
	}
	else
	{
		$TempCartTemplate = str_replace('[User.Name.RequiredDataColor]', 'FFFFFF', $TempCartTemplate);
	}
	
	if ($_SESSION['User.Email'] == '')
	{
		$TempCartTemplate = str_replace('[User.Email.RequiredDataColor]', 'FFFF00', $TempCartTemplate);
	}
	else
	{
		$TempCartTemplate = str_replace('[User.Email.RequiredDataColor]', 'FFFFFF', $TempCartTemplate);
	}

	$TempShippingData = DBGetShippingData($TempTongue);
	$TempLocations = $TempShippingData['Locations'];

	if ($_SESSION['ShippingLocation'] == 0)
	{
		$TempCurrentLocation = $TempLocations[0];
		$TempCartTemplate = str_replace('[SelectedLocation.Name]', 'Local Pickup', $TempCartTemplate);
	}
	else
	{
		if (count($TempLocations) > 0)
		{
			$TempCurrentLocation = $TempLocations[($_SESSION['ShippingLocation']-1)];
			$TempCartTemplate = str_replace('[SelectedLocation.Name]', $TempLocations[($_SESSION['ShippingLocation']-1)]['Name'], $TempCartTemplate);
		}
		else
		{
			echo "Please add shipping locations to the database.<br>";
		}
	}
	
	$TempCouponValue = GetCouponValue();
	
	$TempSubTotal = GetCartItemsTotal();
	$TempSubTotal = $TempSubTotal + 0; // Calculate shipping
	
	// Calculate Coupon
	
	$TempCartTemplate = str_replace('[CouponValue]', number_format(-$TempCouponValue,2), $TempCartTemplate);
	
	$TempTaxesTotals = GetTaxesTotals($TempCurrentLocation['Taxes'], $TempSubTotal);
	
	$TempShippingAmount = 0;
	$TempShippingRate = 0;
	$TempShippingName = '';
	
	if ($_SESSION['ShippingLocation'] > 0)
	{
		$TempShippingRate = GetShippingRate($TempCurrentLocation, $TempShippingData);
		$TempShippingAmount = $TempShippingRate['Price'] + $TempShippingRate['HandlingFee'];
	}
	$TempCartTotal = $TempSubTotal + $TempShippingAmount - $TempCouponValue;
	$TempCartTemplate = str_replace('[Cart.Total2]', number_format($TempCartTotal,2), $TempCartTemplate);
	
	$TempCartTotal = $TempSubTotal + $TempShippingAmount + array_sum($TempTaxesTotals) - $TempCouponValue;
	$TempCartTemplate = str_replace('[Cart.Total3]', number_format($TempCartTotal,2), $TempCartTemplate);
	
	$_SESSION['Order.Total'] = $TempCartTotal;
	
	if ($TempShippingData <> '' and $_SESSION['ShippingLocation'] <> 0)
	{
		$TempShippingName = GetStringListItemWithZeroFallBack($TempShippingData['ShippingService']['Name'], $TempTongue);
		$TempCartTemplate = str_replace('[Shipping.Service.Name]', $TempShippingName, $TempCartTemplate);
		$TempCartTemplate = str_replace('[Shipping.Box.Name]', $TempShippingData['Box']['Name'], $TempCartTemplate);
	}
	else
	{
		$TempCartTemplate = str_replace('[Shipping.Service.Name]', '', $TempCartTemplate);
		$TempCartTemplate = str_replace('[Shipping.Box.Name]', '', $TempCartTemplate);
	}

	if (is_array($TempShippingRate))
	{
		// Shipping rate found
		$TempCartTemplate = str_replace('[Shipping]', number_format($TempShippingAmount,2), $TempCartTemplate);
		$TempCartTemplate = str_replace('[ShippingNotFound]', '', $TempCartTemplate);
	}
	else
	{
		if ($TempShippingRate == 0)
		{
			// Local pickup
			$TempCartTemplate = str_replace('[Shipping]', "0", $TempCartTemplate);
			$TempCartTemplate = str_replace('[ShippingNotFound]', '', $TempCartTemplate);
		}
		else
		{
			// No shipping rate found
			$TempCartTemplate = str_replace('[Shipping]', "?", $TempCartTemplate);
			$TempNotFoundTemplate = LoadFile('Templates/TTemplateCartConfirmationShippingNotFound'.$TempTongue.'.txt');
			$TempCartTemplate = str_replace('[ShippingNotFound]', $TempNotFoundTemplate, $TempCartTemplate);
		}
	}
	
	$TempCartTemplate = FillCartTaxes($TempCartTemplate, $TempTongue, $TempCurrentLocation['Taxes'], $TempTaxesTotals, $TempSubTotal);
	
	if ($TempShowDelayNote)
	{
		$TempCartNote = LoadFile('Templates/TTemplateCartNotesDelay'.$TempTongue.'.txt');
		$TempCartTemplate = str_replace('[DelayNote]', $TempCartNote, $TempCartTemplate);
	}
	else
	{
		$TempCartTemplate = str_replace('[DelayNote]', '', $TempCartTemplate);
	}
	
	if ($TempShowReleaseDateNote)
	{
		$TempCartNote = LoadFile('Templates/TTemplateCartNotesReleaseDate'.$TempTongue.'.txt');
		$TempCartTemplate = str_replace('[ReleaseDateNote]', $TempCartNote, $TempCartTemplate);
	}
	else
	{
		$TempCartTemplate = str_replace('[ReleaseDateNote]', '', $TempCartTemplate);
	}
	
	$TempLocationsOptions = "\n";

	for ($t = 0; $t <= count($TempLocations) - 1; $t++)
	{
		if ($_SESSION['ShippingLocation'] == $t+1)
		{
			$TempOption = '<option value="L'.($t+1).'" selected>'.$TempLocations[$t]['Name'].'</option>';
		}
		else
		{
			$TempOption = '<option value="L'.($t+1).'">'.$TempLocations[$t]['Name'].'</option>';
		}
		
		$TempLocationsOptions = $TempLocationsOptions.$TempOption."\n";

	}
	
	// Show shipping result template
	if (is_array($TempShippingRate))
	{
		// Shipping rate found
		$TempCartTemplate = FillShipping(true, $TempCartTemplate, $TempTongue, $TempCartTotal);
	}
	else
	{
		if ($TempShippingRate == 0)
		{
			// Local pickup
			$TempCartTemplate = FillShipping(true, $TempCartTemplate, $TempTongue, $TempCartTotal);
		}
		else
		{
			// No shipping rate found
			$TempCartTemplate = FillShipping(false, $TempCartTemplate, $TempTongue, $TempCartTotal);
		}
	}
	

	$TempCartTemplate = str_replace('[LocationsList]', $TempLocationsOptions, $TempCartTemplate);
	
	//$_SESSION('LastCatalogueResult')
	//[LastResultsLink]
	
	if (array_key_exists('LastCatalogueResult', $_SESSION))
	{
		$TempCartTemplate = str_replace('[LastResultsLink]', 'Show.php?Data='.$_SESSION['LastCatalogueResult'].'&Sort='.$_SESSION['Sort'], $TempCartTemplate);
	}
	else
	{
		$TempCartTemplate = str_replace('[LastResultsLink]', 'Show.php?Data=Main', $TempCartTemplate);
	}
	
	if ($TempShow)
	{
		echo $TempCartTemplate;
	}

	return $TempCartTemplate;
}

function FillShipping($TempShippingResult, $TempCartTemplate, $TempTongue, $TempCartTotal)
{
	if ($TempShippingResult)
	{
		$TempTemplate = LoadFile('Templates/TTemplateCartConfirmationShippingFound'.$TempTongue.'.txt');

		$TempTemplate = str_replace('[Order.No]', $_SESSION['Order.No'], $TempTemplate);
		$TempTemplate = str_replace('[Order.Total]', $TempCartTotal, $TempTemplate);
	}
	else
	{
		$TempTemplate = LoadFile('Templates/TTemplateCartConfirmationShippingNotFound'.$TempTongue.'.txt');
	}
	
	$TempTemplate = str_replace('[Language]', $TempTongue, $TempTemplate);
	
	
	if ((!$_SESSION['User.Name'] == '') and (!$_SESSION['User.Email'] == '') and (count($_SESSION['Products']) > 0))
	{
		$TempCartTemplate = str_replace('[ShippingResult]', $TempTemplate, $TempCartTemplate);
	}
	else
	{
		$TempCartTemplate = str_replace('[ShippingResult]', '', $TempCartTemplate);
	}
	
	return $TempCartTemplate;
}

function GetShippingRate($TempLocation, &$TempShippingName)
{
	$TempReturn = 0;
	
	$TempCartTotal = GetCartItemsTotal();
	
	$TempTotalWeight = GetCartItemsTotalWeigth();
	$TempCartCubicSize = GetCartCubicSize();

	$TempValidRates = array();
	
	// Get rates that can accept the total weight
	for ($t = 0; $t <= count($TempLocation['Rates']) - 1; $t++)
	{
		$TempService = $TempLocation['Rates'][$t]['ShippingService'];
		$TempDimensions = $TempLocation['Rates'][$t]['Box']['Dimensions'];
		$TempMaxWeight = $TempService['MaxWeight'];
		
		$TempTotalWeightWithBox = $TempTotalWeight + $TempDimensions['Weight'];
		
		if ($TempTotalWeightWithBox <= $TempMaxWeight)
		{
			if ($_SESSION['Settings']['RequireTrackingForOrdersOver'] == 0)		
			{
				// No tracking required
				$TempValidRates[] = $t;	
			}
			else
			{
				// Tracking required
				
				if ($TempCartTotal > $_SESSION['Settings']['RequireTrackingForOrdersOver'])
				{
					// Total requires tracking
					if ($TempService['HasTrackingNumber'] == "True")
					{
						$TempValidRates[] = $t;	
					}
				}
				else
				{
					// Total does not require tracking
					$TempValidRates[] = $t;	
				}
			}
		}

	}
	
			//var_dump($TempService['HasTrackingNumber']);
	
	$TempOldValidRates = $TempValidRates;
	$TempValidRates = array();
	
	// Get the selected rates that can accept the dimensions
	for ($t = 0; $t <= count($TempOldValidRates) - 1; $t++)
	{
		$TempBoxDimensions = $TempLocation['Rates'][($TempOldValidRates[$t])]['Box']['Dimensions'];
		$TempBoxMaxTotalDimension = $TempLocation['Rates'][($TempOldValidRates[$t])]['Box']['MaxTotalDimension'];
		// Verify if each item can fit in the box
		
		$TempPassed = true;
		
		if ($TempBoxMaxTotalDimension > 0)
		{
			if ($TempCartCubicSize > $TempBoxMaxTotalDimension)
			{
				$TempPassed = false;
			}
		}
		
		for ($g = 0; $g <= count($_SESSION['Products']) - 1; $g++)
		{
			if (array_sum($_SESSION['Products'][$g]['Quantities']) > 0)
			{
				$TempProductDimensions = GetCartProductDimensions($_SESSION['Products'][$g]);
				
				for ($h = 0; $h <= count($_SESSION['Products'][$g]['Quantities']) - 1; $h++)
				{
					
					for ($h = 0; $h <= count($TempProductDimensions) - 1; $h++)
					{
						if ($_SESSION['Products'][$g]['Quantities'][$h] > 0)
						{
							if ($TempBoxMaxTotalDimension == 0)
							{
								if (
										($TempProductDimensions[$h]['Width'] > $TempBoxDimensions['Width']
											or $TempProductDimensions[$h]['Height'] > $TempBoxDimensions['Height']
											or $TempProductDimensions[$h]['Length'] > $TempBoxDimensions['Length'])
										
										and ($TempProductDimensions[$h]['Length'] > $TempBoxDimensions['Width']
											or $TempProductDimensions[$h]['Width'] > $TempBoxDimensions['Height']
											or $TempProductDimensions[$h]['Height'] > $TempBoxDimensions['Length'])
										
										and ($TempProductDimensions[$h]['Height'] > $TempBoxDimensions['Width']
											or $TempProductDimensions[$h]['Length'] > $TempBoxDimensions['Height']
											or $TempProductDimensions[$h]['Width'] > $TempBoxDimensions['Length']))
								{
									$TempPassed = false;
								}
								
								if ($TempProductDimensions[$h]['Weight'] == 0)
								{
									$TempPassed = false;
								}
							}
						}
					}
				}
			}
			
		}
		
		if ($TempPassed)
		{
			$TempValidRates[] = $TempOldValidRates[$t];
		}
	}
	
	// Get the smallest closest cubic size
	$TempOldValidRates = $TempValidRates;

	$TempBestFit = -1;
	//$TempSmallestCubic = 99999999;
	$TempLowestPrice = 99999;
	
	for ($t = 0; $t <= count($TempOldValidRates) - 1; $t++)
	{
		$TempBoxDimensions = $TempLocation['Rates'][($TempOldValidRates[$t])]['Box']['Dimensions'];
		$TempBoxCubicSize = GetCubicSize($TempBoxDimensions);
		
		//if (($TempBoxCubicSize - $TempCartCubicSize) < $TempSmallestCubic
		//		and ($TempBoxCubicSize - $TempCartCubicSize) >=0)
		//{
		//	$TempSmallestCubic = $TempBoxCubicSize - $TempCartCubicSize;
		//	$TempBestFit = $TempOldValidRates[$t];
		//}
		
		if ($TempLocation['Rates'][($TempOldValidRates[$t])]["Price"] < $TempLowestPrice)
		{
			$TempLowestPrice = $TempLocation['Rates'][($TempOldValidRates[$t])]["Price"];
			$TempBestFit = $TempOldValidRates[$t];
		}
		
	}

	if ($TempBestFit >= 0)
	{
		$TempShippingName = $TempLocation['Rates'][$TempBestFit];
		$TempReturn = $TempLocation['Rates'][$TempBestFit];
	}
	else
	{
		$TempShippingName = array();
		$TempShippingName = '';
		$TempReturn = -1;
	}

	if ($TempCartTotal == 0)
	{
	$TempReturn = -1;
	}
	
	
	return $TempReturn;
}

function GetCartCubicSize()
{
	$TempReturn = 0;
	
	for ($t = 0; $t <= count($_SESSION['Products']) - 1; $t++)
	{
		$TempReturn = $TempReturn + GetCartProductCubicSize($_SESSION['Products'][$t]);
	}
	
	//echo($TempReturn)."<br>";
	
	return $TempReturn;
}

function GetCartProductCubicSize($TempProductArray)
{
	$TempReturn = 0;
	
	$TempResult = GetCartProductDimensions($TempProductArray);
	
	for ($t = 0; $t <= count($TempResult) - 1; $t++)
	{
		$TempReturn = $TempReturn + GetCubicSize($TempResult[$t]) * $TempProductArray['Quantities'][$t];
	}
	
	return $TempReturn;
}

function GetCartProductDimensions($TempProductArray)
{
	$TempReturn = array();
	
	$TempQuantities = $TempProductArray['Quantities'];
	$TempProduct = $TempProductArray['Product'];
	
	// Get single item dimensions
	$TempReturn[] = $TempProductArray['Product']['Dimensions'];
	
	// Get bundles dimensions
	for ($t = 0; $t <= count($TempProduct['Bundles']) - 1; $t++)
	{
		$TempReturn[] = $TempProduct['Bundles'][$t]['Dimensions'];
	}
	
	return $TempReturn;
}

function GetTaxesTotals($TempTaxes, $TempSubTotal)
{
	$TempSubTotal = 0;
		
	$TempData = '';
	$TempTaxAmount = 0;

	$TempCouponRemainingValue = GetCouponValue();

	// Get each product total
	$TempProductTotals = array();
	
	for ($h = 0; $h <= count($_SESSION['Products']) - 1; $h++)
	{
		$TempProductTotals[] = GetItemTotal($_SESSION['Products'][$h]);
		
		// Remove the coupon value from the product if a coupon value is remaining
		if ($TempCouponRemainingValue > 0)
		{

			if ($TempProductTotals[$h] > $TempCouponRemainingValue)
			{
				// The item value is bigger than the coupon value, use all the coupon value
				$TempProductTotals[$h] = $TempProductTotals[$h] - $TempCouponRemainingValue;
				$TempCouponRemainingValue = 0;
			}
			else
			{
				// The coupon value is bigger than the item value, clear the item and remove it's value from the coupon
				$TempCouponRemainingValue = $TempCouponRemainingValue - $TempProductTotals[$h];
				$TempProductTotals[$h] = 0;
			}
		}
	}
	
	$TempPreviousTaxes = array();
	
	$TempExcludeArray = array();
	// Get excluded products for each tax
	for ($t = 0; $t <= count($TempTaxes) - 1; $t++)
	{
		$TempExcludeArray[$t] = array();
			for ($h = 0; $h <= count($_SESSION['Products']) - 1; $h++)
			{
				$TempExcludeArray[$t][$h] = false;
				$TempExclude[] = '1';
			}
		
		$TempExclude = array();
		
		for ($g = 0; $g <= count($TempTaxes[$t]['ExcludedProductsByProperties']) - 1; $g++)
		{
			$TempTaxExclude = $TempTaxes[$t]['ExcludedProductsByProperties'][$g]['Name'];
			$TempTaxExclude = $TempTaxExclude.":==->".$TempTaxes[$t]['ExcludedProductsByProperties'][$g]['Value'];
			
			
			for ($h = 0; $h <= count($_SESSION['Products']) - 1; $h++)
			{
				//echo $_SESSION['Products'][$h]['Product']['Name']." (".$TempTaxes[$t]['Name'].")".$TempTaxExclude.": ";
				
				if (in_array($TempTaxExclude, $_SESSION['Products'][$h]['PropertyValues']))
				{
					//$TempExclude[$h] = true;
					$TempExcludeArray[$t][$h] = true;
					//echo "true<br>";
				}
				else
				{
					//$TempExclude[] = false;
					//echo "<br>";
				}
			}
		}
	
		
		//echo "<br>Final TempExcludeArray: ";
		//var_dump($TempExcludeArray);
		//AddBr(2);
		
		//$TempExcludeArray[] = $TempExclude;
	}
	//echo "TempExcludeArray: ";
	//var_dump($TempExcludeArray);
	//AddBr(2);
	// Calculate each product tax
	$TempTaxesTotals = array();
	
	//echo "TempProductTotals: ";
	//var_dump($TempProductTotals);
	//AddBr(2);
	
	//echo "TempTaxes: ";
	//var_dump($TempTaxes);
	//AddBr(2);

	for ($t = 0; $t <= count($TempProductTotals) - 1; $t++)
	{
		for ($g = 0; $g <= count($TempTaxes) - 1; $g++)
		{
			if (count($TempExcludeArray[$g]) > 0)
			{
				if (!$TempExcludeArray[$g][$t])
				{
					$TempTaxesTotals[$t][$g] = $TempProductTotals[$t];
				}
				else
				{
					$TempTaxesTotals[$t][$g] = 0;
				}
			}
			else
			{
				$TempTaxesTotals[$t][$g] = $TempProductTotals[$t];
			}
		}
	}
	
	$TempShippingData = DBGetShippingData(0);
	$TempLocations = $TempShippingData['Locations'];
	$TempShippingAmount = 0;
	
	if ($_SESSION['ShippingLocation'] > 0)
	{
		$TempCurrentLocation = $TempLocations[($_SESSION['ShippingLocation']-1)];
		$TempShippingRate = GetShippingRate($TempCurrentLocation, $TempShippingName);
		$TempShippingAmount = $TempShippingRate['Price'] + $TempShippingRate['HandlingFee'];
	}
	$TempTaxesTotalIdx = count($TempTaxesTotals);
	
	// Add taxes to shipping
	for ($g = 0; $g <= count($TempTaxes) - 1; $g++)
	{
		$TempTaxesTotals[$TempTaxesTotalIdx][$g] = $TempShippingAmount;
	}
	
	$TempFinalTaxes = array();
	
	for ($g = 0; $g <= count($TempTaxes) - 1; $g++)
	{
		$TempFinalTaxes[$g] = 0;
	}
	
	for ($t = 0; $t <= count($TempTaxesTotals) - 1; $t++)
	{
		for ($g = 0; $g <= count($TempTaxes) - 1; $g++)
		{
			$TempFinalTaxes[$g] = $TempFinalTaxes[$g] + $TempTaxesTotals[$t][$g];
		}
	}
//var_dump($TempFinalTaxes);
//AddBr(1);

	for ($g = 0; $g <= count($TempTaxes) - 1; $g++)
	{
		if ($TempTaxes[$g]['AddPreviousTaxesToTotal'] == 'True')
		{
			$TempOriginalTotal = $TempFinalTaxes[$g];
			
			if ($TempFinalTaxes[$g] <> 0)
			{
//echo "TempFinalTaxes[$g]1: ".$TempFinalTaxes[$g]."<br>";
				$TempFinalTaxes[$g] = RoundUpFrom($TempOriginalTotal * ($TempTaxes[$g-1]['Percentage']/100),$TempTaxes[$g-1]['RoundUpFrom']);
//echo "TempFinalTaxes[$g]2: ".$TempFinalTaxes[$g]."<br>";
				$TempFinalTaxes[$g] = RoundUpFrom(($TempOriginalTotal+$TempFinalTaxes[$g]) * ($TempTaxes[$g]['Percentage']/100),$TempTaxes[$g]['RoundUpFrom']);
//echo "TempFinalTaxes[$g]3: ".$TempFinalTaxes[$g]."<br>";
			}
			
		}
		else
		{
			$TempFinalTaxes[$g] = RoundUpFrom($TempFinalTaxes[$g] * ($TempTaxes[$g]['Percentage']/100),$TempTaxes[$g]['RoundUpFrom']);
//echo "TempFinalTaxes[$g]4: ".$TempFinalTaxes[$g]."<br>";
		}
	}
	//var_dump($TempFinalTaxes);
	return $TempFinalTaxes;
}

function FillCartTaxes($TempTemplate, $TempTongue, $TempTaxes, $TempTaxesTotals, $TempSubTotal)
{
	$TempTaxLineTemplate = LoadFile('Templates/TTemplateCartTaxLine'.$TempTongue.'.txt');
	$TempData = '';
	
	for ($t = 0; $t <= count($TempTaxesTotals) - 1; $t++)
	{
		$TempLine = $TempTaxLineTemplate;
		$TempLine = str_replace('[Tax.Name]', $TempTaxes[$t]['Name'], $TempLine);
		$TempLine = str_replace('[Tax.Percentage]', $TempTaxes[$t]['Percentage'], $TempLine);

		$TempLine = str_replace('[Tax.Amount]', number_format($TempTaxesTotals[$t],2), $TempLine);
		
		$TempData = $TempData.$TempLine;
	}

	$TempTemplate = str_replace('[Taxes]', $TempData, $TempTemplate);

	return $TempTemplate;
}

function FillCartData($TempTemplate, $TempTongue)
{
	$TempTemplate = str_replace('[Language]', $TempTongue, $TempTemplate);
	
	$TempTemplate = str_replace('[Cart.Items.Count]', count($_SESSION['Products']), $TempTemplate);
	
	$TempCartSubTotal = GetCartItemsTotal() - GetCouponValue();
	
	$TempTemplate = str_replace('[Cart.Total1]', number_format($TempCartSubTotal,2), $TempTemplate);
	
	$TempTemplate = str_replace('[Cart.TotalWeight]', number_format(GetCartItemsTotalWeigth(),2), $TempTemplate);
	
	return $TempTemplate;
}

function GetCouponValue()
{
	$TempCouponValue = 0;
	
	if (!array_key_exists('User.CouponData', $_SESSION))
	{
	$_SESSION['User.CouponData'] = '';
	}
	
	if ($_SESSION['User.CouponData'] <> '')
	{
		if ($_SESSION['User.CouponData']['IsPercentage'])
		{
		}
		else
		{
			if ($_SESSION['User.CouponData']['MinimumOrder'] >= 0)
			{
				if (GetCartItemsTotal() > $_SESSION['User.CouponData']['MinimumOrder'])
				{
				$TempCouponValue = $_SESSION['User.CouponData']['Value'];
				}
			}
			else
			{
				$TempCouponValue = $_SESSION['User.CouponData']['Value'];
			}
		}
	}

	return $TempCouponValue;
}

function FillCartItemData($TempTemplate, $TempTongue, &$TempProductArray, $TempShow = true)
{
	global $TempShowDelayNote;
	global $TempShowReleaseDateNote;

	$TempCartDelayWeeksTemplate = LoadFile('Templates/TTemplateCartProductInfosDelay'.$TempTongue.'.txt');
	$TempCartReleaseDateTemplate = LoadFile('Templates/TTemplateCartProductInfosReleaseDate'.$TempTongue.'.txt');

	$TempReturn = $TempTemplate;
	
	$TempProduct = $TempProductArray['Product'];
	
	$TempReturn = str_replace('[Cart.Item.Orders]', FillProductBundles($TempProductArray, $TempTongue, $TempShow), $TempReturn);
	$TempReturn = str_replace('[ProductRemoveLink]', 'cart.php?Action=Remove&ID='.$TempProduct['ID'].'&Lang='.$TempTongue, $TempReturn);
	
	$TempReturn = str_replace('[Object.Name]', $TempProduct['Name'], $TempReturn);
	$TempReturn = str_replace('[Object.ID]', $TempProduct['ID'], $TempReturn);
	$TempReturn = str_replace('[Cart.Item.Qty]', '', $TempReturn);
	$TempReturn = str_replace('[Object.Price]', number_format(GetMemberPrice($TempProduct['Price']),2), $TempReturn);
	$TempReturn = str_replace('[Cart.Item.Total]', number_format(GetItemTotal($TempProductArray),2), $TempReturn);
	
	if (!$TempProduct['SpecialOrderDelayWeeks'] == '')
	{
		$TempCartDelayWeeksTemplate = str_replace('[Cart.Item.DelayWeeks]', $TempProduct['SpecialOrderDelayWeeks'], $TempCartDelayWeeksTemplate);
		$TempReturn = str_replace('[Cart.Item.Delay]', $TempCartDelayWeeksTemplate, $TempReturn);
		$TempShowDelayNote = true;
		
	}
	else
	{
		$TempReturn = str_replace('[Cart.Item.Delay]', '', $TempReturn);
	}

	if ($TempProduct['UseReleaseDate'])
	{
		$TempCartReleaseDateTemplate = str_replace('[Cart.Item.ReleaseDate]',date("Y-m-d",$TempProduct['ReleaseDate']),$TempCartReleaseDateTemplate);
		$TempReturn = str_replace('[Cart.Item.ReleaseDate]', $TempCartReleaseDateTemplate, $TempReturn);
		$TempShowReleaseDateNote = true;
	}
	else
	{
		$TempReturn = str_replace('[Cart.Item.ReleaseDate]', '', $TempReturn);
	}

	$ThumbnailFileName = '';
	if (count($TempProduct['Pictures.FileName']) > 0)
	{
		$ThumbnailFileName = GetThumbnailFileName($TempProduct['Pictures.FileName'][0]);
	}
	else
	{
			$TempExtension = '';
			
			if (file_exists('Pictures/NoPicture.png'))
			{
				$TempExtension = ".png";
			}
			else
			{
				if (file_exists('Pictures/NoPicture.gif'))
				{
					$TempExtension = ".gif";
				}
				else
				{
					if (file_exists('Pictures/NoPicture.jpg'))
					{
						$TempExtension = ".jpg";
					}
				}
			}
			
			if ($TempExtension <> '')
			{
				$ThumbnailFileName = 'NoPicture'.$TempExtension;
			}
			else
			{
				$ThumbnailFileName = '';
			}

	}
	$TempThumbCode = '<img border="0" src="Pictures/'.$ThumbnailFileName.'" >';
	$TempReturn = str_replace('[Thumbnail]', $TempThumbCode, $TempReturn);
	
	$TempReturn = str_replace('[ThumbnailFileName]', $ThumbnailFileName, $TempReturn);
	
	$TempReturn = str_replace('[ProductLink]', 'Product.php?ID='.$TempProduct['ID'].'&Lang='.$TempTongue, $TempReturn);
	
	$TempDiscountType = $TempProduct['Price']['Discount']['DiscountType'];
	
	switch ($TempDiscountType)
	{
	case 0:
		// Regular Price
		break;
		
	case 1:
		// Fixed Amount
		$TempReturn = str_replace('[Object.Discount]', number_format($TempProduct['Price']['Price']-$TempProduct['Price']['Discount']['Value'],2), $TempReturn);
		break;
		
	}
	
	return $TempReturn;
	
}

function FillProductBundles(&$TempProductArray, $TempTongue, $TempShow = true)
{
	
	$TempReturn = '';
	$TempBundleLineTemplate = '';
	
	$TempOutOfStockTemplate = LoadFile('Templates/TTemplateConfirmedOrderEmailBundleLine'.$TempTongue.'.txt');
	
	if ($TempShow)
	{
		$TempReturn = LoadFile('Templates/TTemplateCartBundleFormModifyButton'.$TempTongue.'.txt');
		$TempBundleLineTemplate = LoadFile('Templates/TTemplateCartBundleLineQuantityEdit'.$TempTongue.'.txt');
	}
	else
	{
		$TempReturn = '[BundleLines]';
		$TempBundleLineTemplate = LoadFile('Templates/TTemplateConfirmedOrderEmailBundleLine'.$TempTongue.'.txt');
	}
	
	$TempBundlesOutput = '';
	
	$TempProduct = $TempProductArray['Product'];
	$TempBundles = $TempProduct['Bundles'];
	$TempQuantities = $TempProductArray['Quantities'];
	
	$TempReturn = str_replace('[Product.ID]', $TempProduct['ID'], $TempReturn);
	$TempReturn = str_replace('[Language]', $TempTongue, $TempReturn);
	
	// Add single item
	$TempBundle = array();
	$TempBundle['Name'] = array();
	$TempBundle['Name'][]='';
	
	if ($TempProduct['InStock'] > 0)
	{
		$TempItemTemplate = $TempBundleLineTemplate;
		//$TempQuantities[0] = 1;
		//$TempProductArray['Quantities'][0] = 1;
	}
	else
	{
		$TempItemTemplate = $TempOutOfStockTemplate;
		$TempQuantities[0] = 0;
		$TempProductArray['Quantities'][0] = 0;
	}
	
	$TempBundle['Quantity'] = '1';
	$TempBundle['Order.Qty'] = $TempQuantities[0];
	
	$TempPrice = array();
	$TempBundle['Price'] = $TempProduct['Price'];//$TempPrice;
	
	FillBundleData($TempItemTemplate, $TempBundle, $TempTongue);
	
	$TempItemTemplate = str_replace('[Product.ID]', $TempProduct['ID'], $TempItemTemplate);
	$TempItemTemplate = str_replace('[Bundle.ID]', 'B0', $TempItemTemplate);
	
	$TempBundlesOutput = $TempBundlesOutput.$TempItemTemplate;
	
	// Add bundles
	
	for ($t = 0; $t <= count($TempBundles) - 1; $t++)
	{
		if ($TempBundles[$t]['InStock'] > 0)
		{
			$TempItemTemplate = $TempBundleLineTemplate;
		}
		else
		{
			$TempItemTemplate = $TempOutOfStockTemplate;
		}
		
		$TempBundles[$t]['Order.Qty'] = $TempQuantities[$t+1];
		
		FillBundleData($TempItemTemplate, $TempBundles[$t], $TempTongue);
		
		$TempBundleID = 'B'.($t+1);
		
		$TempItemTemplate = str_replace('[Product.ID]', $TempProduct['ID'], $TempItemTemplate);
		$TempItemTemplate = str_replace('[Bundle.ID]', $TempBundleID, $TempItemTemplate);
		
		$TempBundlesOutput = $TempBundlesOutput.$TempItemTemplate;

	}
	
	$TempReturn = str_replace('[BundleLines]', $TempBundlesOutput, $TempReturn);
	
	return $TempReturn;
	
}

function FillBundleData(&$TempTemplate, $TempBundle, $TempTongue)
{
	$TempTemplate = str_replace('[Bundle.Name]', GetStringListItemWithZeroFallBack($TempBundle['Name'], $TempTongue), $TempTemplate);

	$TempTemplate = str_replace('[Bundle.FinalPrice]', number_format(DBGetFinalPrice($TempBundle['Price']),2), $TempTemplate);
	$TempTemplate = str_replace('[Bundle.Qty]', $TempBundle['Quantity'], $TempTemplate);
	$TempTemplate = str_replace('[Bundle.Order.Qty]', $TempBundle['Order.Qty'], $TempTemplate);
}

function GetProductFromProductArray($TempID)
{
	$TempReturn = '';
	
	$TempCount = count($_SESSION['Products']);
	
	for ($t = 0; $t <= $TempCount -1 ; $t++)
	{
		if ($_SESSION['Products'][$t]['ID'] == $TempID)
		{
			$TempReturn = $_SESSION['Products'][$t];
		}
	}
	
	return $TempReturn;
}

function GetProductIndexFromProductArray($TempID)
{
	
	$TempReturn = -1;
	
	$TempCount = count($_SESSION['Products']);
	
	for ($t = 0; $t <= $TempCount -1 ; $t++)
	{
		
		if ($_SESSION['Products'][$t]['ID'] == $TempID)
		{
			$TempReturn = $t;
		}
	}
	
	return $TempReturn;
}

function SetProductToProductArray($TempID, $TempProductArray)
{
	
	$TempIndex = GetProductIndexFromProductArray($TempProductArray['Product']['ID']);
	
	$_SESSION['Products'][$TempIndex] = $TempProductArray;
	
}

function GetItemTotal($TempProductArray)
{
	$TempReturn = 0;
	
	$TempProduct = $TempProductArray['Product'];
	$TempBundles = $TempProduct['Bundles'];
	$TempQuantities = $TempProductArray['Quantities'];
	
	$TempReturn = $TempQuantities[0] * DBGetFinalPrice($TempProduct['Price']);
	
	for ($t = 0; $t <= count($TempQuantities)-2; $t++)
	{
		$TempReturn = $TempReturn + $TempQuantities[($t+1)] * DBGetFinalPrice($TempProduct['Bundles'][$t]['Price']);
	}
	
	return $TempReturn;
}

function GetCartItemsTotal()
{
	$TempReturn = 0;
	
	for ($t = 0; $t <= count($_SESSION['Products']) - 1; $t++)
	{
		$TempDiscountType = $_SESSION['Products'][$t]['Product']['Price']['Discount']['DiscountType'];
		
		$TempReturn = $TempReturn + GetItemTotal($_SESSION['Products'][$t]);
	}

	return $TempReturn;
}

function GetCartItemsTotalWeigth()
{
	$TempReturn = 0;
	
	for ($t = 0; $t <= count($_SESSION['Products']) - 1; $t++)
	{
		$TempReturn = $TempReturn + GetCartItemTotalWeight($_SESSION['Products'][$t]);
	}

	return $TempReturn;
}

function GetCartItemTotalWeight($TempProductArray)
{
	$TempReturn = 0;
	
	$TempProduct = $TempProductArray['Product'];
	$TempBundles = $TempProduct['Bundles'];
	$TempQuantities = $TempProductArray['Quantities'];
	
	$TempReturn = $TempQuantities[0] * $TempProduct['Dimensions']['Weight'];
	
	for ($t = 0; $t <= count($TempQuantities)-2; $t++)
	{
		$TempReturn = $TempReturn + $TempQuantities[($t+1)] * $TempProduct['Bundles'][$t]['Dimensions']['Weight'];
	}
	
	return $TempReturn;
}

?>
